// Copyright (C) 2023 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:wyatt_architecture/wyatt_architecture.dart';
import 'package:wyatt_authentication_bloc/wyatt_authentication_bloc.dart';
import 'package:wyatt_type_utils/wyatt_type_utils.dart';

class ExampleAuthenticationCubit extends AuthenticationCubit<int> {
  ExampleAuthenticationCubit({required super.authenticationRepository});

  @override
  FutureOrResult<int?> onReauthenticate(
      Result<Account, AppException> result) async {
    print('onReauthenticate');

    return const Ok(1);
  }

  @override
  FutureOrResult<int?> onRefresh(Result<Account, AppException> result) {
    print('onRefresh');

    return const Ok(1);
  }

  @override
  FutureOrResult<int?> onSignInFromCache(AuthenticationSession<int> session) {
    print('onSignInFromCache');

    return const Ok(1);
  }

  @override
  FutureOrResult<void> onSignOut() {
    print('onSignOut');

    return const Ok(null);
  }

  @override
  FutureOrResult<void> onDelete() {
    print('onDelete');

    return const Ok(null);
  }
}
